import { PipeTransform } from '@angular/core';
export declare class HumanizedDurationPipe implements PipeTransform {
    /**
     * Method allowing to transform a duration (ISOString)
     * @param value String value (ISOString) linked to a duration.
     * @returns The humanized value (not sensitive to the current locale).
     */
    transform(value: string): string;
}
