(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ui-frontend-common/testing', ['exports', '@angular/core', '@angular/forms'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global['ui-frontend-common'] = global['ui-frontend-common'] || {}, global['ui-frontend-common'].testing = {}), global.ng.core, global.ng.forms));
}(this, (function (exports, core, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (b.hasOwnProperty(p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    function __createBinding(o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    }
    function __exportStar(m, exports) {
        for (var p in m)
            if (p !== "default" && !exports.hasOwnProperty(p))
                exports[p] = m[p];
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (Object.hasOwnProperty.call(mod, k))
                    result[k] = mod[k];
        result.default = mod;
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var NavbarStubComponent = /** @class */ (function () {
        function NavbarStubComponent() {
            this.hideTenantMenu = false;
            this.hideCustomerMenu = false;
        }
        return NavbarStubComponent;
    }());
    NavbarStubComponent.decorators = [
        { type: core.Component, args: [{ selector: 'vitamui-common-navbar', template: '<ng-content></ng-content>' },] }
    ];
    NavbarStubComponent.propDecorators = {
        appId: [{ type: core.Input }],
        hideTenantMenu: [{ type: core.Input }],
        hideCustomerMenu: [{ type: core.Input }],
        customers: [{ type: core.Input }]
    };
    var ApplicationSelectContentStubComponent = /** @class */ (function () {
        function ApplicationSelectContentStubComponent() {
        }
        return ApplicationSelectContentStubComponent;
    }());
    ApplicationSelectContentStubComponent.decorators = [
        { type: core.Component, args: [{ selector: 'vitamui-common-application-select-content', template: '<ng-content></ng-content>' },] }
    ];
    ApplicationSelectContentStubComponent.propDecorators = {
        applications: [{ type: core.Input }],
        categories: [{ type: core.Input }],
        isModalMenu: [{ type: core.Input }]
    };
    var VitamUICustomerSelectStubComponent = /** @class */ (function () {
        function VitamUICustomerSelectStubComponent() {
        }
        return VitamUICustomerSelectStubComponent;
    }());
    VitamUICustomerSelectStubComponent.decorators = [
        { type: core.Component, args: [{ selector: 'vitamui-common-customer-select', template: '<ng-content></ng-content>' },] }
    ];
    var VitamUIDurationInputStubComponent = /** @class */ (function () {
        function VitamUIDurationInputStubComponent() {
        }
        VitamUIDurationInputStubComponent.prototype.writeValue = function () { };
        VitamUIDurationInputStubComponent.prototype.registerOnChange = function () { };
        VitamUIDurationInputStubComponent.prototype.registerOnTouched = function () { };
        return VitamUIDurationInputStubComponent;
    }());
    VitamUIDurationInputStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-vitamui-duration-input',
                    template: '<ng-content></ng-content>',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUIDurationInputStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    VitamUIDurationInputStubComponent.propDecorators = {
        placeholder: [{ type: core.Input }]
    };
    var VitamUITenantSelectStubComponent = /** @class */ (function () {
        function VitamUITenantSelectStubComponent() {
        }
        return VitamUITenantSelectStubComponent;
    }());
    VitamUITenantSelectStubComponent.decorators = [
        { type: core.Component, args: [{ selector: 'vitamui-common-tenant-select', template: '<ng-content></ng-content>' },] }
    ];
    var StepperStubComponent = /** @class */ (function () {
        function StepperStubComponent() {
        }
        return StepperStubComponent;
    }());
    StepperStubComponent.decorators = [
        { type: core.Component, args: [{ selector: 'vitamui-common-stepper', template: '<ng-content></ng-content>' },] }
    ];
    StepperStubComponent.propDecorators = {
        selectedIndex: [{ type: core.Input }]
    };
    var VitamUIInputErrorStubComponent = /** @class */ (function () {
        function VitamUIInputErrorStubComponent() {
        }
        return VitamUIInputErrorStubComponent;
    }());
    VitamUIInputErrorStubComponent.decorators = [
        { type: core.Component, args: [{ selector: 'vitamui-common-input-error', template: '<ng-content></ng-content>' },] }
    ];
    var VitamUIInputStubComponent = /** @class */ (function () {
        function VitamUIInputStubComponent() {
        }
        VitamUIInputStubComponent.prototype.writeValue = function () { };
        VitamUIInputStubComponent.prototype.registerOnChange = function () { };
        VitamUIInputStubComponent.prototype.registerOnTouched = function () { };
        return VitamUIInputStubComponent;
    }());
    VitamUIInputStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-input',
                    template: '',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUIInputStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    VitamUIInputStubComponent.propDecorators = {
        placeholder: [{ type: core.Input }]
    };
    var VitamUIInputPositiveNumberStubComponent = /** @class */ (function () {
        function VitamUIInputPositiveNumberStubComponent() {
        }
        VitamUIInputPositiveNumberStubComponent.prototype.writeValue = function () { };
        VitamUIInputPositiveNumberStubComponent.prototype.registerOnChange = function () { };
        VitamUIInputPositiveNumberStubComponent.prototype.registerOnTouched = function () { };
        return VitamUIInputPositiveNumberStubComponent;
    }());
    VitamUIInputPositiveNumberStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-input-positive-number',
                    template: '',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUIInputPositiveNumberStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    VitamUIInputPositiveNumberStubComponent.propDecorators = {
        placeholder: [{ type: core.Input }]
    };
    var VitamUIListInputStubComponent = /** @class */ (function () {
        function VitamUIListInputStubComponent() {
        }
        VitamUIListInputStubComponent.prototype.writeValue = function () { };
        VitamUIListInputStubComponent.prototype.registerOnChange = function () { };
        VitamUIListInputStubComponent.prototype.registerOnTouched = function () { };
        return VitamUIListInputStubComponent;
    }());
    VitamUIListInputStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-list-input',
                    template: '',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUIListInputStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    VitamUIListInputStubComponent.propDecorators = {
        placeholder: [{ type: core.Input }]
    };
    var VitamUITextareaStubComponent = /** @class */ (function () {
        function VitamUITextareaStubComponent() {
        }
        VitamUITextareaStubComponent.prototype.writeValue = function () { };
        VitamUITextareaStubComponent.prototype.registerOnChange = function () { };
        VitamUITextareaStubComponent.prototype.registerOnTouched = function () { };
        return VitamUITextareaStubComponent;
    }());
    VitamUITextareaStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-textarea',
                    template: '',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUITextareaStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    VitamUITextareaStubComponent.propDecorators = {
        placeholder: [{ type: core.Input }]
    };
    var VitamUISlideToggleStubComponent = /** @class */ (function () {
        function VitamUISlideToggleStubComponent() {
        }
        VitamUISlideToggleStubComponent.prototype.writeValue = function (value) { this.value = value; };
        VitamUISlideToggleStubComponent.prototype.registerOnChange = function () { };
        VitamUISlideToggleStubComponent.prototype.registerOnTouched = function () { };
        return VitamUISlideToggleStubComponent;
    }());
    VitamUISlideToggleStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-slide-toggle',
                    template: '<ng-content></ng-content>',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUISlideToggleStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    VitamUISlideToggleStubComponent.propDecorators = {
        disabled: [{ type: core.Input }],
        checked: [{ type: core.Input }]
    };
    // Editable fields
    // tslint:disable-next-line:directive-class-suffix
    var EditableFieldStubComponent = /** @class */ (function () {
        function EditableFieldStubComponent() {
        }
        EditableFieldStubComponent.prototype.writeValue = function (value) { this.value = value; };
        EditableFieldStubComponent.prototype.registerOnChange = function () { };
        EditableFieldStubComponent.prototype.registerOnTouched = function () { };
        return EditableFieldStubComponent;
    }());
    EditableFieldStubComponent.decorators = [
        { type: core.Directive }
    ];
    EditableFieldStubComponent.propDecorators = {
        validator: [{ type: core.Input }],
        asyncValidator: [{ type: core.Input }]
    };
    var VitamUIEditableEmailInputStubComponent = /** @class */ (function (_super) {
        __extends(VitamUIEditableEmailInputStubComponent, _super);
        function VitamUIEditableEmailInputStubComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return VitamUIEditableEmailInputStubComponent;
    }(EditableFieldStubComponent));
    VitamUIEditableEmailInputStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-editable-email-input',
                    template: '{{value}}',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUIEditableEmailInputStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    VitamUIEditableEmailInputStubComponent.propDecorators = {
        domains: [{ type: core.Input }]
    };
    var VitamUIFieldErrorStubComponent = /** @class */ (function () {
        function VitamUIFieldErrorStubComponent() {
        }
        return VitamUIFieldErrorStubComponent;
    }());
    VitamUIFieldErrorStubComponent.decorators = [
        { type: core.Component, args: [{ selector: 'vitamui-common-field-error', template: '<ng-content></ng-content>' },] }
    ];
    var VitamUIEditableFileStubComponent = /** @class */ (function (_super) {
        __extends(VitamUIEditableFileStubComponent, _super);
        function VitamUIEditableFileStubComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return VitamUIEditableFileStubComponent;
    }(EditableFieldStubComponent));
    VitamUIEditableFileStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-editable-file',
                    template: '{{value}}',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUIEditableFileStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    var VitamUIEditableInputStubComponent = /** @class */ (function (_super) {
        __extends(VitamUIEditableInputStubComponent, _super);
        function VitamUIEditableInputStubComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return VitamUIEditableInputStubComponent;
    }(EditableFieldStubComponent));
    VitamUIEditableInputStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-editable-input',
                    template: '{{value}}',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUIEditableInputStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    var VitamUIEditableTextareaStubComponent = /** @class */ (function (_super) {
        __extends(VitamUIEditableTextareaStubComponent, _super);
        function VitamUIEditableTextareaStubComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return VitamUIEditableTextareaStubComponent;
    }(EditableFieldStubComponent));
    VitamUIEditableTextareaStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-editable-textarea',
                    template: '{{value}}',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUIEditableTextareaStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    var VitamUIEditableSelectStubComponent = /** @class */ (function (_super) {
        __extends(VitamUIEditableSelectStubComponent, _super);
        function VitamUIEditableSelectStubComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return VitamUIEditableSelectStubComponent;
    }(EditableFieldStubComponent));
    VitamUIEditableSelectStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-editable-select',
                    template: '{{value}}',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUIEditableSelectStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    var VitamUIEditableOptionStubComponent = /** @class */ (function () {
        function VitamUIEditableOptionStubComponent() {
        }
        return VitamUIEditableOptionStubComponent;
    }());
    VitamUIEditableOptionStubComponent.decorators = [
        { type: core.Component, args: [{ selector: 'vitamui-common-editable-option', template: '' },] }
    ];
    VitamUIEditableOptionStubComponent.propDecorators = {
        value: [{ type: core.Input }],
        content: [{ type: core.Input }],
        disabled: [{ type: core.Input }]
    };
    var VitamUIEditableToggleGroupStubComponent = /** @class */ (function (_super) {
        __extends(VitamUIEditableToggleGroupStubComponent, _super);
        function VitamUIEditableToggleGroupStubComponent() {
            return _super !== null && _super.apply(this, arguments) || this;
        }
        return VitamUIEditableToggleGroupStubComponent;
    }(EditableFieldStubComponent));
    VitamUIEditableToggleGroupStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-editable-toggle-group',
                    template: '{{value}}',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return VitamUIEditableToggleGroupStubComponent; }),
                            multi: true,
                        }]
                },] }
    ];
    var VitamUIEditableButtonToggleStubComponent = /** @class */ (function () {
        function VitamUIEditableButtonToggleStubComponent() {
        }
        return VitamUIEditableButtonToggleStubComponent;
    }());
    VitamUIEditableButtonToggleStubComponent.decorators = [
        { type: core.Component, args: [{ selector: 'vitamui-common-editable-button-toggle', template: '' },] }
    ];
    VitamUIEditableButtonToggleStubComponent.propDecorators = {
        value: [{ type: core.Input }]
    };
    var EditableLevelInputStubComponent = /** @class */ (function () {
        function EditableLevelInputStubComponent() {
        }
        EditableLevelInputStubComponent.prototype.writeValue = function () { };
        EditableLevelInputStubComponent.prototype.registerOnChange = function () { };
        EditableLevelInputStubComponent.prototype.registerOnTouched = function () { };
        return EditableLevelInputStubComponent;
    }());
    EditableLevelInputStubComponent.decorators = [
        { type: core.Component, args: [{
                    selector: 'vitamui-common-editable-level-input',
                    template: '{{prefix}}',
                    providers: [{
                            provide: forms.NG_VALUE_ACCESSOR,
                            useExisting: core.forwardRef(function () { return EditableLevelInputStubComponent; }),
                            multi: true
                        }]
                },] }
    ];
    EditableLevelInputStubComponent.propDecorators = {
        validator: [{ type: core.Input }],
        asyncValidator: [{ type: core.Input }],
        prefix: [{ type: core.Input }],
        disabled: [{ type: core.Input }]
    };
    var StrongifyStubPipe = /** @class */ (function () {
        function StrongifyStubPipe() {
        }
        StrongifyStubPipe.prototype.transform = function (value) { return value; };
        return StrongifyStubPipe;
    }());
    StrongifyStubPipe.decorators = [
        { type: core.Pipe, args: [{ name: 'strongify' },] }
    ];
    var TruncateStubPipe = /** @class */ (function () {
        function TruncateStubPipe() {
        }
        TruncateStubPipe.prototype.transform = function (value) {
            if (value === void 0) { value = ''; }
            return value;
        };
        return TruncateStubPipe;
    }());
    TruncateStubPipe.decorators = [
        { type: core.Pipe, args: [{ name: 'truncate' },] }
    ];
    var TranslateStubPipe = /** @class */ (function () {
        function TranslateStubPipe() {
        }
        TranslateStubPipe.prototype.transform = function (value) {
            if (value === void 0) { value = ''; }
            return value;
        };
        return TranslateStubPipe;
    }());
    TranslateStubPipe.decorators = [
        { type: core.Pipe, args: [{ name: 'translate' },] }
    ];
    var InfiniteScrollStubDirective = /** @class */ (function () {
        function InfiniteScrollStubDirective() {
            this.vitamuiScroll = new core.EventEmitter();
        }
        return InfiniteScrollStubDirective;
    }());
    InfiniteScrollStubDirective.decorators = [
        { type: core.Directive, args: [{ selector: '[vitamuiCommonInfiniteScroll]' },] }
    ];
    InfiniteScrollStubDirective.propDecorators = {
        vitamuiCommonInfiniteScrollThreshold: [{ type: core.Input }],
        vitamuiCommonInfiniteScrollDisable: [{ type: core.Input }],
        vitamuiScroll: [{ type: core.Output }]
    };
    var RowCollapseStubDirective = /** @class */ (function () {
        function RowCollapseStubDirective() {
        }
        return RowCollapseStubDirective;
    }());
    RowCollapseStubDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[vitamuiCommonRowCollapse]',
                    exportAs: 'vitamuiRowCollapse'
                },] }
    ];
    RowCollapseStubDirective.propDecorators = {
        vitamuiCommonCollapse: [{ type: core.Input }]
    };
    var RowCollapseTriggerForStubDirective = /** @class */ (function () {
        function RowCollapseTriggerForStubDirective() {
        }
        return RowCollapseTriggerForStubDirective;
    }());
    RowCollapseTriggerForStubDirective.decorators = [
        { type: core.Directive, args: [{
                    selector: '[vitamuiCommonRowCollapseTriggerFor]'
                },] }
    ];
    RowCollapseTriggerForStubDirective.propDecorators = {
        vitamuiCommonRowCollapseTriggerFor: [{ type: core.Input }]
    };
    var VitamUICommonTestModule = /** @class */ (function () {
        function VitamUICommonTestModule() {
        }
        return VitamUICommonTestModule;
    }());
    VitamUICommonTestModule.decorators = [
        { type: core.NgModule, args: [{
                    declarations: [
                        ApplicationSelectContentStubComponent,
                        VitamUICustomerSelectStubComponent,
                        VitamUIDurationInputStubComponent,
                        VitamUIEditableButtonToggleStubComponent,
                        VitamUIEditableEmailInputStubComponent,
                        VitamUIEditableFileStubComponent,
                        VitamUIEditableInputStubComponent,
                        VitamUIEditableOptionStubComponent,
                        VitamUIEditableSelectStubComponent,
                        VitamUIEditableTextareaStubComponent,
                        VitamUIEditableToggleGroupStubComponent,
                        VitamUIFieldErrorStubComponent,
                        VitamUIInputErrorStubComponent,
                        VitamUIInputPositiveNumberStubComponent,
                        VitamUIInputStubComponent,
                        VitamUIListInputStubComponent,
                        VitamUISlideToggleStubComponent,
                        VitamUITenantSelectStubComponent,
                        VitamUITextareaStubComponent,
                        EditableLevelInputStubComponent,
                        InfiniteScrollStubDirective,
                        NavbarStubComponent,
                        RowCollapseStubDirective,
                        RowCollapseTriggerForStubDirective,
                        StepperStubComponent,
                        StrongifyStubPipe,
                        TruncateStubPipe,
                        TranslateStubPipe
                    ],
                    exports: [
                        ApplicationSelectContentStubComponent,
                        VitamUICustomerSelectStubComponent,
                        VitamUIDurationInputStubComponent,
                        VitamUIEditableButtonToggleStubComponent,
                        VitamUIEditableEmailInputStubComponent,
                        VitamUIEditableFileStubComponent,
                        VitamUIEditableInputStubComponent,
                        VitamUIEditableOptionStubComponent,
                        VitamUIEditableSelectStubComponent,
                        VitamUIEditableTextareaStubComponent,
                        VitamUIEditableToggleGroupStubComponent,
                        VitamUIFieldErrorStubComponent,
                        VitamUIInputErrorStubComponent,
                        VitamUIInputPositiveNumberStubComponent,
                        VitamUIInputStubComponent,
                        VitamUIListInputStubComponent,
                        VitamUISlideToggleStubComponent,
                        VitamUITenantSelectStubComponent,
                        VitamUITextareaStubComponent,
                        EditableLevelInputStubComponent,
                        InfiniteScrollStubDirective,
                        NavbarStubComponent,
                        RowCollapseStubDirective,
                        RowCollapseTriggerForStubDirective,
                        StepperStubComponent,
                        StrongifyStubPipe,
                        TruncateStubPipe,
                        TranslateStubPipe
                    ]
                },] }
    ];

    function input(elInput, value) {
        elInput.value = value;
        var customEvent = document.createEvent('CustomEvent');
        customEvent.initCustomEvent('input', false, false, null);
        elInput.dispatchEvent(customEvent);
    }
    function submit(form) {
        // Calling nativeElement.submit() causes the test page to refresh indefinitely so we have to use triggerEventHandler() instead
        form.triggerEventHandler('submit', null);
    }

    /*
     * Copyright French Prime minister Office/SGMAP/DINSIC/Vitam Program (2019-2020)
     * and the signatories of the "VITAM - Accord du Contributeur" agreement.
     *
     * contact@programmevitam.fr
     *
     * This software is a computer program whose purpose is to implement
     * implement a digital archiving front-office system for the secure and
     * efficient high volumetry VITAM solution.
     *
     * This software is governed by the CeCILL-C license under French law and
     * abiding by the rules of distribution of free software.  You can  use,
     * modify and/ or redistribute the software under the terms of the CeCILL-C
     * license as circulated by CEA, CNRS and INRIA at the following URL
     * "http://www.cecill.info".
     *
     * As a counterpart to the access to the source code and  rights to copy,
     * modify and redistribute granted by the license, users are provided only
     * with a limited warranty  and the software's author,  the holder of the
     * economic rights,  and the successive licensors  have only  limited
     * liability.
     *
     * In this respect, the user's attention is drawn to the risks associated
     * with loading,  using,  modifying and/or developing or reproducing the
     * software by the user in light of its specific status of free software,
     * that may mean  that it is complicated to manipulate,  and  that  also
     * therefore means  that it is reserved for developers  and  experienced
     * professionals having in-depth computer knowledge. Users are therefore
     * encouraged to load and test the software's suitability as regards their
     * requirements in conditions enabling the security of their systems and/or
     * data to be ensured and,  more generally, to use and operate it in the
     * same conditions as regards security.
     *
     * The fact that you are presently reading this means that you have had
     * knowledge of the CeCILL-C license and that you accept its terms.
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.ApplicationSelectContentStubComponent = ApplicationSelectContentStubComponent;
    exports.EditableFieldStubComponent = EditableFieldStubComponent;
    exports.EditableLevelInputStubComponent = EditableLevelInputStubComponent;
    exports.InfiniteScrollStubDirective = InfiniteScrollStubDirective;
    exports.NavbarStubComponent = NavbarStubComponent;
    exports.RowCollapseStubDirective = RowCollapseStubDirective;
    exports.RowCollapseTriggerForStubDirective = RowCollapseTriggerForStubDirective;
    exports.StepperStubComponent = StepperStubComponent;
    exports.StrongifyStubPipe = StrongifyStubPipe;
    exports.TranslateStubPipe = TranslateStubPipe;
    exports.TruncateStubPipe = TruncateStubPipe;
    exports.VitamUICommonTestModule = VitamUICommonTestModule;
    exports.VitamUICustomerSelectStubComponent = VitamUICustomerSelectStubComponent;
    exports.VitamUIDurationInputStubComponent = VitamUIDurationInputStubComponent;
    exports.VitamUIEditableButtonToggleStubComponent = VitamUIEditableButtonToggleStubComponent;
    exports.VitamUIEditableEmailInputStubComponent = VitamUIEditableEmailInputStubComponent;
    exports.VitamUIEditableFileStubComponent = VitamUIEditableFileStubComponent;
    exports.VitamUIEditableInputStubComponent = VitamUIEditableInputStubComponent;
    exports.VitamUIEditableOptionStubComponent = VitamUIEditableOptionStubComponent;
    exports.VitamUIEditableSelectStubComponent = VitamUIEditableSelectStubComponent;
    exports.VitamUIEditableTextareaStubComponent = VitamUIEditableTextareaStubComponent;
    exports.VitamUIEditableToggleGroupStubComponent = VitamUIEditableToggleGroupStubComponent;
    exports.VitamUIFieldErrorStubComponent = VitamUIFieldErrorStubComponent;
    exports.VitamUIInputErrorStubComponent = VitamUIInputErrorStubComponent;
    exports.VitamUIInputPositiveNumberStubComponent = VitamUIInputPositiveNumberStubComponent;
    exports.VitamUIInputStubComponent = VitamUIInputStubComponent;
    exports.VitamUIListInputStubComponent = VitamUIListInputStubComponent;
    exports.VitamUISlideToggleStubComponent = VitamUISlideToggleStubComponent;
    exports.VitamUITenantSelectStubComponent = VitamUITenantSelectStubComponent;
    exports.VitamUITextareaStubComponent = VitamUITextareaStubComponent;
    exports.input = input;
    exports.submit = submit;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ui-frontend-common-testing.umd.js.map
