import { EventEmitter } from '@angular/core';
import { AuthService } from '../../auth.service';
import { Application } from '../../models/application/application.interface';
import { Category } from '../../models/application/category.interface';
export declare class ApplicationSelectContentComponent {
    private authService;
    isModalMenu: boolean;
    set applications(applications: Application[]);
    get applications(): Application[];
    private _applications;
    set categories(categories: Category[]);
    get categories(): Category[];
    private _categories;
    applicationSelected: EventEmitter<string>;
    get target(): string;
    categoryList: any[];
    constructor(authService: AuthService);
    checkTenantNumberByApp(apps: Application[]): void;
    computeAppCategories(): void;
    selectApp(value: string): void;
}
