import { Observable } from 'rxjs';
import { ComponentType } from '@angular/cdk/portal';
import { TemplateRef } from '@angular/core';
import { MatDialog, MatDialogRef } from '@angular/material/dialog';
export declare class ConfirmDialogService {
    private matDialog;
    constructor(matDialog: MatDialog);
    confirm(componentOrTemplateRef: TemplateRef<unknown> | ComponentType<unknown>): Observable<boolean>;
    listenToEscapeKeyPress(matDialogRef: MatDialogRef<unknown>): Observable<any>;
    confirmBeforeClosing(matDialogRef: MatDialogRef<unknown>): void;
}
