import { ControlValueAccessor, FormControl } from '@angular/forms';
export declare const EMAILS_INPUT_ACCESSOR: any;
export declare class EmailsInputComponent implements ControlValueAccessor {
    placeholder: string;
    spinnerDiameter: number;
    emails: string[];
    control: FormControl;
    separatorKeysCodes: number[];
    onChange: (_: any) => void;
    onTouched: () => void;
    constructor();
    writeValue(emails: string[]): void;
    registerOnChange(fn: (_: any) => void): void;
    registerOnTouched(fn: () => void): void;
    add(): void;
    remove(email: string): void;
    buttonAddDisabled(): boolean;
    get emailExists(): boolean;
}
