import { AfterContentInit, OnChanges, OnInit, QueryList } from '@angular/core';
import { Direction } from '../../vitamui-table';
import { OrderOptionComponent } from './order-option/order-option.component';
export declare class OrderDropdownComponent implements AfterContentInit, OnInit, OnChanges {
    orderBy: string;
    direction: Direction;
    options: QueryList<OrderOptionComponent>;
    dropdownOpen: boolean;
    active: boolean;
    constructor();
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngOnChanges(): void;
    private refreshActiveOption;
}
