import { HttpClient } from '@angular/common/http';
import { Observable } from 'rxjs';
export declare class ExternalParametersService {
    private http;
    private baseUrl;
    private readonly apiUrl;
    constructor(http: HttpClient, baseUrl: string);
    /**
     * Get the external parameters for the authenticated user
     * @returns the user parameters map
     */
    getUserExternalParameters(): Observable<Map<string, string>>;
}
