import { Id } from '../id.interface';
export interface Event extends Id {
    idRequest: string;
    parentId: string;
    type: string;
    typeProc: string;
    dateTime: Date;
    outcome: string;
    outDetail: string;
    outMessage: string;
    data: string;
    parsedData: {
        [key: string]: any;
    };
    objectId: string;
    collectionName: string;
    agId: string;
    agIdApp: string;
    agIdExt: string;
    rightsStatementIdentifier: string;
    obIdReq: string;
    userIdentifier?: string;
    subrogatorIdentifier?: string;
    events?: Event[];
}
