interface VitamQueryKeyValue {
    [key: string]: any;
}
interface VitamQueryKeyValues {
    [key: string]: any[];
}
interface VitamQueryOperatorAnd {
    $and: VitamSelectOperator | VitamSelectOperator[];
}
interface VitamQueryOperatorOr {
    $or: VitamSelectOperator | VitamSelectOperator[];
}
interface VitamQueryOperatorNot {
    $not: VitamSelectOperator | VitamSelectOperator[];
}
interface VitamQueryOperatorEqual {
    $eq: VitamQueryKeyValue;
}
interface VitamQueryOperatorNotEqual {
    $ne: VitamQueryKeyValue;
}
interface VitamQueryOperatorLowerThan {
    $lt: VitamQueryKeyValue;
}
interface VitamQueryOperatorLowerThanEqual {
    $lte: VitamQueryKeyValue;
}
interface VitamQueryOperatorGreaterThan {
    $gt: VitamQueryKeyValue;
}
interface VitamQueryOperatorGreaterThanEqual {
    $gte: VitamQueryKeyValue;
}
interface VitamQueryOperatorRange {
    $range: {
        [key: string]: {
            $lt?: Date;
            $lte?: Date;
            $gt?: Date;
            $gte?: Date;
        };
    };
}
interface VitamQueryOperatorIn {
    $in: VitamQueryKeyValues;
}
interface VitamQueryOperatorNotIn {
    $nin: VitamQueryKeyValues;
}
export declare type VitamSelectOperator = VitamQueryOperatorAnd | VitamQueryOperatorOr | VitamQueryOperatorNot | VitamQueryOperatorEqual | VitamQueryOperatorNotEqual | VitamQueryOperatorLowerThan | VitamQueryOperatorLowerThanEqual | VitamQueryOperatorGreaterThan | VitamQueryOperatorGreaterThanEqual | VitamQueryOperatorRange | VitamQueryOperatorIn | VitamQueryOperatorNotIn;
export {};
