import { OnDestroy, OnInit, TemplateRef, ViewContainerRef } from '@angular/core';
import { Subscription } from 'rxjs';
import { SecurityService } from './security.service';
export declare class HasRoleDirective implements OnInit, OnDestroy {
    private templateRef;
    private viewContainer;
    private securityService;
    roleSubscription: Subscription;
    private viewEmbedded;
    constructor(templateRef: TemplateRef<any>, viewContainer: ViewContainerRef, securityService: SecurityService);
    ngOnInit(): void;
    ngOnDestroy(): void;
    set vitamuiCommonHasRole(data: {
        appId: string;
        tenantIdentifier: number;
        role: string;
    });
}
