import { MatSnackBar } from '@angular/material/snack-bar';
import { ActivatedRouteSnapshot, CanActivate, CanActivateChild, Router } from '@angular/router';
import { ApplicationService } from './application.service';
import { AuthService } from './auth.service';
import { TenantSelectionService } from './tenant-selection.service';
export declare class TenantSelectionGuard implements CanActivate, CanActivateChild {
    private authService;
    private snackBar;
    private appService;
    private router;
    private tenantService;
    private location;
    constructor(authService: AuthService, snackBar: MatSnackBar, appService: ApplicationService, router: Router, tenantService: TenantSelectionService, location: any);
    canActivate(route: ActivatedRouteSnapshot): boolean;
    canActivateChild(route: ActivatedRouteSnapshot): boolean;
}
